<?php
/******************************
 * WoWRoster.net  UniAdmin
 * Copyright 2002-2006
 * Licensed under the Creative Commons
 * "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * Short summary
 *  http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * Full license information
 *  http://creativecommons.org/licenses/by-nc-sa/2.5/legalcode
 * -----------------------------
 *
 * $Id: addons.php 252 2006-10-16 02:08:55Z zanix $
 *
 ******************************/

if( !defined('IN_UNIADMIN') )
{
    exit('Detected invalid access to this file!');
}

// Get Operation
$op = ( isset($_POST[UA_URI_OP]) ? $_POST[UA_URI_OP] : '' );

$id = ( isset($_POST[UA_URI_ID]) ? $_POST[UA_URI_ID] : '' );

// Decide What To Do
switch($op)
{
	case UA_URI_PROCESS:
		if( $user->data['level'] >= UA_ID_ADMIN )
			process_addon();
		break;

	case UA_URI_DELETE:
		if( $user->data['level'] >= UA_ID_ADMIN )
			delete_addon($id);
		break;

	case UA_URI_REQ:
		if( $user->data['level'] >= UA_ID_POWER )
			require_addon($id);
		break;

	case UA_URI_OPT:
		if( $user->data['level'] >= UA_ID_POWER )
			optional_addon($id);
		break;

	case UA_URI_DISABLE:
		if( $user->data['level'] >= UA_ID_POWER )
			disable_addon($id);
		break;

	case UA_URI_ENABLE:
		if( $user->data['level'] >= UA_ID_POWER )
			enable_addon($id);
		break;

	default:
		break;
}
main();








/**
 * Addon Page Functions
 */


/**
 * Main Display
 */
function main( )
{
	global $db, $uniadmin, $user, $tpl;

	$tpl->assign_vars(array(
		'L_ADDON_MANAGE'   => $user->lang['addon_management'],
		'L_NAME'           => $user->lang['name'],
		'L_TOC'            => $user->lang['toc'],
		'L_REQUIRED'       => $user->lang['required'],
		'L_VERSION'        => $user->lang['version'],
		'L_UPLOADED'       => $user->lang['uploaded'],
		'L_ENABLED'        => $user->lang['enabled'],
		'L_FILES'          => $user->lang['files'],
		'L_DELETE'         => $user->lang['delete'],
		'L_DISABLE_ENABLE' => $user->lang['disable_enable'],
		'L_SELECT_FILE'    => $user->lang['select_file'],
		'L_DOWNLOAD'       => $user->lang['download'],
		'L_ADD_UPDATE'     => $user->lang['add_update_addon'],
		'L_REQUIRED_ADDON' => $user->lang['required_addon'],
		'L_SELECT_FILE'    => $user->lang['select_file'],
		'L_HOMEPAGE'       => $user->lang['homepage'],
		'L_NOTES'       => $user->lang['notes'],
		'L_GO'             => $user->lang['go'],

		'L_NO_ADDONS'      => $user->lang['error_no_addon_in_db'],

		'S_ADDONS'         => true,
		'S_ADDON_ADD_DEL'  => false,
		)
	);

	if( $user->data['level'] == UA_ID_ADMIN )
	{
		$tpl->assign_var('S_ADDON_ADD_DEL',true);
	}

	if( $user->data['level'] == UA_ID_ANON )
	{
		$tpl->assign_var('L_ADDON_MANAGE',$user->lang['view_addons']);
	}

	$sql = "SELECT * FROM `".UA_TABLE_ADDONS."` ORDER BY `name`;";
	$result = $db->query($sql);

	if( $db->num_rows($result) > 0 )
	{
		while( $row = $db->fetch_record($result) )
		{
			$sql = "SELECT * FROM `".UA_TABLE_FILES."` WHERE `addon_id` = '".$row['id']."';";
			$result2 = $db->query($sql);
			$num_files = $db->num_rows($result2);
			$db->free_result($result2);

			$addon_name = $row['name'];
			$homepage = $row['homepage'];
			$version = $row['version'];
			$notes = $row['notes'];
			$time = date($user->lang['time_format'],$row['time_uploaded']);
			$url = $row['dl_url'];
			$addon_id = $row['id'];

			if( $row['enabled'] == '1' )
			{
				$enabled = '<form name="ua_disableaddon_'.$addon_id.'" style="display:inline;" method="post" enctype="multipart/form-data" action="'.UA_FORMACTION.'">
	<input type="hidden" name="'.UA_URI_OP.'" value="'.UA_URI_DISABLE.'" />
	<input type="hidden" name="'.UA_URI_ID.'" value="'.$addon_id.'" />
	<input class="submit" style="color:green;" type="submit" value="'.$user->lang['yes'].'" />
</form>';
				if( $user->data['level'] <= UA_ID_USER )
				{
					$enabled = '<span style="color:green;">'.$user->lang['yes'].'</span>';
				}
			}
			else
			{
				$enabled = '<form name="ua_enableaddon_'.$addon_id.'" style="display:inline;" method="post" enctype="multipart/form-data" action="'.UA_FORMACTION.'">
	<input type="hidden" name="'.UA_URI_OP.'" value="'.UA_URI_ENABLE.'" />
	<input type="hidden" name="'.UA_URI_ID.'" value="'.$addon_id.'" />
	<input class="submit" style="color:red;" type="submit" value="'.$user->lang['no'].'" />
</form>';
				if( $user->data['level'] <= UA_ID_USER )
				{
					$enabled = '<span style="color:red;">'.$user->lang['no'].'</span>';
				}
			}

			if( $row['homepage'] == '' )
			{
				$homepage = './';
			}

			if( $row['required'] == 1 )
			{
				$required = '<form name="ua_optionaladdon_'.$addon_id.'" style="display:inline;" method="post" enctype="multipart/form-data" action="'.UA_FORMACTION.'">
	<input type="hidden" name="'.UA_URI_OP.'" value="'.UA_URI_OPT.'" />
	<input type="hidden" name="'.UA_URI_ID.'" value="'.$addon_id.'" />
	<input class="submit" style="color:red;" type="submit" value="'.$user->lang['yes'].'" />
</form>';
				if( $user->data['level'] <= UA_ID_USER )
				{
					$required = '<span style="color:red;">'.$user->lang['yes'].'</span>';
				}
			}
			else
			{
				$required = '<form name="ua_requireaddon_'.$addon_id.'" style="display:inline;" method="post" enctype="multipart/form-data" action="'.UA_FORMACTION.'">
	<input type="hidden" name="'.UA_URI_OP.'" value="'.UA_URI_REQ.'" />
	<input type="hidden" name="'.UA_URI_ID.'" value="'.$addon_id.'" />
	<input class="submit" style="color:green;" type="submit" value="'.$user->lang['no'].'" />
</form>';
				if( $user->data['level'] <= UA_ID_USER )
				{
					$required = '<span style="color:green;">'.$user->lang['no'].'</span>';
				}
			}

			$toc = $row['toc'];

			$tpl->assign_block_vars('addons_row', array(
				'ROW_CLASS'   => $uniadmin->switch_row_class(),
				'ID'          => $addon_id,
				'HOMEPAGE'    => $homepage,
				'NOTES'       => $notes,
				'ADDONNAME'   => $addon_name,
				'TOC'         => $toc,
				'REQUIRED'    => $required,
				'VERSION'     => $version,
				'TIME'        => $time,
				'ENABLED'     => $enabled,
				'NUMFILES'    => $num_files,
				'DOWNLOAD'    => $url,
				)
			);
		}
	}
	else
	{
		$tpl->assign_var('S_ADDONS',false);
	}

	$db->free_result($result);

	$uniadmin->set_vars(array(
		'page_title'    => $user->lang['title_addons'],
		'template_file' => 'addons.html',
		'display'       => true
		)
	);
}

/**
 * Disables an addon
 *
 * @param int $id
 */
function disable_addon( $id )
{
	global $db, $user, $uniadmin;

	$sql = "UPDATE `".UA_TABLE_ADDONS."` SET `enabled` = '0' WHERE `id` = '$id' LIMIT 1 ;";
	$db->query($sql);
	if( !$db->affected_rows() )
	{
	    $uniadmin->debug($user->lang['error_disable_addon']);
		$uniadmin->debug(sprintf($user->lang['sql_error_addons_disable'],$id));
	}
}

/**
 * Enables an addon
 *
 * @param int $id
 */
function enable_addon( $id )
{
	global $db, $user, $uniadmin;

	$sql = "UPDATE `".UA_TABLE_ADDONS."` SET `enabled` = '1' WHERE `id` = '$id' LIMIT 1 ;";
	$db->query($sql);
	if( !$db->affected_rows() )
	{
	    $uniadmin->debug($user->lang['error_enable_addon']);
		$uniadmin->debug(sprintf($user->lang['sql_error_addons_enable'],$id));
	}
}

/**
 * Sets an addon to required
 *
 * @param int $id
 */
function require_addon( $id )
{
	global $db, $user, $uniadmin;

	$sql = "UPDATE `".UA_TABLE_ADDONS."` SET `required` = '1' WHERE `id` = '$id' LIMIT 1 ;";
	$db->query($sql);
	if( !$db->affected_rows() )
	{
	    $uniadmin->debug($user->lang['error_require_addon']);
		$uniadmin->debug(sprintf($user->lang['sql_error_addons_require'],$id));
	}
}

/**
 * Sets an addon to optional
 *
 * @param int $id
 */
function optional_addon( $id )
{
	global $db, $user, $uniadmin;

	$sql = "UPDATE `".UA_TABLE_ADDONS."` SET `required` = '0' WHERE `id` = '$id' LIMIT 1 ;";
	$db->query($sql);
	if( !$db->affected_rows() )
	{
	    $uniadmin->debug($user->lang['error_optional_addon']);
		$uniadmin->debug(sprintf($user->lang['sql_error_addons_optional'],$id));
	}
}

/**
 * Deletes an addon from the server and the database
 *
 * @param int $id
 */
function delete_addon( $id )
{
	global $db, $user, $uniadmin;

	$sql = "SELECT * FROM `".UA_TABLE_ADDONS."` WHERE `id` = '$id'";
	$result = $db->query($sql);
	$row = $db->fetch_record($result);

	$id = $row['id'];
	$addon_url = $row['dl_url'];
	$k = explode('/',$addon_url);
	$addon_file_name = $k[count($k) - 1];

	$local_path = UA_BASEDIR.$uniadmin->config['addon_folder'].DIR_SEP.$addon_file_name;
	$try_unlink = @unlink($local_path);
	if( !$try_unlink )
	{
		$uniadmin->debug($user->lang['error_delete_addon']);
		$uniadmin->debug(sprintf($user->lang['error_unlink'],$local_path));
	}

	$sql = "DELETE FROM `".UA_TABLE_ADDONS."` WHERE `id` = '$id'";
	$db->query($sql);
	if( !$db->affected_rows() )
	{
	    $uniadmin->debug(sprintf($user->lang['sql_error_addons_delete'],$id));
	}

	$sql = "DELETE FROM `".UA_TABLE_FILES."` WHERE `addon_id` = '$id';";
	$db->query($sql);
	if( !$db->affected_rows() )
	{
	    $uniadmin->debug(sprintf($user->lang['sql_error_addons_delete'],$id));
	}
}

/**
 * Processess an uploaded addon for insertion into the database
 */
function process_addon()
{
	global $db, $user, $uniadmin;

	$temp_file_name = $_FILES['file']['tmp_name'];

	if( !empty($temp_file_name) )
	{
		if( $uniadmin->get_file_ext($_FILES['file']['name']) != 'zip' )
		{
			$uniadmin->message($user->lang['error_zip_file']);
			return;
		}

		$url = $uniadmin->url_path;
		$addon_file_name = str_replace(' ','_',$_FILES['file']['name']);

		$addon_zip_folder = UA_BASEDIR.$uniadmin->config['addon_folder'];
		$temp_folder = UA_BASEDIR.$uniadmin->config['temp_analyze_folder'];

		if( isset($_POST['required']) && $_POST['required'] == '1' )
		{
			$required = 1;
		}
		else
		{
			$required = 0;
		}

		// Set Download URL
		$download_url = $url.$uniadmin->config['addon_folder'].'/'.$addon_file_name;

		// Name and location of the zip file
		$zip_file = $addon_zip_folder.DIR_SEP.$addon_file_name;

		// Delete Addon if it exists
		@unlink($zip_file);

		// Try to move to the addon_temp directory
		$try_move = move_uploaded_file($temp_file_name,$zip_file);
		if( !$try_move )
		{
			$uniadmin->debug(sprintf($user->lang['error_move_uploaded_file'],$temp_file_name,$zip_file));
			return;
		}

		// Try to set write access on the uploaded file
		$try_chmod = @chmod($zip_file,0777);
		if( !$try_chmod )
		{
			$uniadmin->debug(sprintf($user->lang['error_chmod'],$zip_file));
			return;
		}

		// Unzip the file
		$uniadmin->unzip($zip_file,$temp_folder.DIR_SEP);

		$files = $uniadmin->ls($temp_folder,array());

		// Get the TOC of the addon
		$toc_file_name = '';
		$toc_files = array();
		if( is_array($files) )
		{
			foreach( $files as $file )
			{
				if( $uniadmin->get_file_ext($file) == 'toc' )
				{
					$toc_files[] = $file;
					continue;
				}
				elseif( strpos($file, 'changelog-r') && $uniadmin->get_file_ext($file) == 'txt' )
				{
					$revision_files[] = $file;
					continue;
				}
			}			
			if( count($toc_files) > 0)
			{
				foreach ( $toc_files as $file )
				{
					$toc = get_toc_val($file, 'Interface', ! empty($_POST['toc']) ? $_POST['toc'] : '00000');

					$k = explode(DIR_SEP,$file);
					$toc_file_name = $k[count($k) - 1];
					$toc_file_name = substr($toc_file_name,0,count($toc_file_name) -5);
					$real_addon_name = ! empty($_POST['name']) ? $_POST['name'] : get_toc_val($file, 'Title', $toc_file_name);
					if( strpos($real_addon_name, 'Ace') && strpos($real_addon_name, '|r'))
					{
						$real_addon_name = trim(substr($real_addon_name, 0, strpos(substr($real_addon_name, 0, strpos($real_addon_name, '|r')), '|')));
					}
					if ( ! empty($_POST['version']))
					{
						$version = $_POST['version'];
					}
					else
					{
						$version = get_toc_val($file, 'Version', '');
						foreach( $revision_files as $revision_file_name )
						{
							if ( substr($revision_file_name, 0, strrpos($revision_file_name, '/')) == substr($file, 0, strrpos($file, '/')) )
							{
								$rev = substr($revision_file_name, ( strrpos($revision_file_name, '/') + strlen('changelog-r') + 1), -4);
								$revision = $rev > $revision ? $rev : $revision;
							}
						}
						if ( ! ( empty($version) || empty($revision) ))
						{
							$version = $version . " | r$revision";
						}
						elseif( empty($version) && ! empty($revision))
						{
							$version = "r$revision";
						}
					}
					$homepage = ! empty($_POST['homepage']) ? $_POST['homepage'] : get_toc_val($file, 'X-Website', get_toc_val($file, 'URL', ''));
					$notes = ! empty($_POST['notes']) ? $_POST['notes'] : get_toc_val($file, 'Notes', '');
					if( ! ( strpos(strtolower($zip_file), strtolower($toc_file_name)) === false && strpos(strtolower($_POST['addon_name']), strtolower($toc_file_name)) === false ) )
					{
						break;
					}
					else
					{
						unset($k, $toc_file_name);
					}
				}
			}
			if( empty($toc_file_name) && empty($_POST['name']) && empty($_POST['toc']))
			{
				$try_unlink = @unlink($zip_file);
				if( !$try_unlink )
				{
					$uniadmin->debug(sprintf($user->lang['error_unlink'],$zip_file));
				}
				$uniadmin->cleardir($temp_folder);
				$uniadmin->debug($user->lang['error_no_toc_file']);
				return;
			}
		}
		else
		{
			$try_unlink = @unlink($zip_file);
			if( !$try_unlink )
			{
				$uniadmin->debug(sprintf($user->lang['error_unlink'],$zip_file));
			}
			$uniadmin->cleardir($temp_folder);
			$uniadmin->debug($user->lang['error_no_files_addon']);
			return;
		}

		// See if AddOn exists in the database and do stuff to it
		$sql = "SELECT * FROM `".UA_TABLE_ADDONS."` WHERE `name` = '".$db->escape($real_addon_name)."';";
		$result = $db->query($sql);

		if( $db->num_rows($result) > 0 )
		{
			$row = $db->fetch_record($result);
			$db->free_result($result);

			$addon_id = $row['id'];

			if( $homepage == '' )
			{
				$homepage = $row['homepage'];
			}
			if( $notes == '' )
			{
				$notes = $row['notes'];
			}
			if( $version == '' )
			{
				$version = $row['version'];
			}

			$enabled = $row['enabled'];

			// Remove files from database since we'll be updating them all
			$sql = "DELETE FROM `".UA_TABLE_FILES."` WHERE `addon_id` = '".$addon_id."';";
			$db->query($sql);

			// Update Main Addon data
			$sql = "UPDATE `".UA_TABLE_ADDONS."` SET `time_uploaded` = '".time()."', `version` = '".$db->escape($version)."', `enabled` = '$enabled', `name` = '".$db->escape($real_addon_name)."', `dl_url` = '".$db->escape($download_url)."', `homepage` = '".$db->escape($homepage)."', `notes` = '".$db->escape($notes)."', `toc` = '$toc', `required` = '$required'
				WHERE `id` = '".$addon_id."';";
			$db->query($sql);
		}
		else
		{
			// Insert Main Addon data
			$sql = "INSERT INTO `".UA_TABLE_ADDONS."` ( `time_uploaded` , `version` , `enabled` , `name`, `dl_url`, `homepage`, `notes`, `toc`, `required` )
				VALUES ( '".time()."', '".$db->escape($version)."', '1', '".$db->escape($real_addon_name)."', '".$db->escape($download_url)."', '".$db->escape($homepage)."', '".$db->escape($notes)."', $toc, $required );";
			$db->query($sql);

			// Get the insert id of the addon just inserted
			$addon_id = $db->insert_id();
		}

		if( !$db->affected_rows() )
		{
		    $uniadmin->debug($user->lang['sql_error_addons_insert']);
		    $uniadmin->cleardir($temp_folder);
		    return;
		}

		// Insert Addon Files' Data
		foreach( $files as $file )
		{
			$md5 = md5_file($file);
			$k = explode(DIR_SEP,$file);
			$pos_t = strpos($file,'addon_temp');
			$addon_file_name = substr($file,$pos_t + 10);

			if( $addon_file_name != 'index.htm' && $addon_file_name != 'index.html' && $addon_file_name != '.svn' )
			{
				$sql = "INSERT INTO `".UA_TABLE_FILES."` ( `addon_id` , `filename` , `md5sum` )
					VALUES ( '".$addon_id."', '".$db->escape($addon_file_name)."', '".$db->escape($md5)."' );";
				$db->query($sql);
				if( !$db->affected_rows() )
				{
				    $uniadmin->debug($user->lang['sql_error_addons_files_insert']);
				    $uniadmin->cleardir($temp_folder);
				    return;
				}

				// We have obtained the md5 and inserted the row into the database, now delete the temp file
				$try_unlink = @unlink($file);
				if( !$try_unlink )
				{
					$uniadmin->debug(sprintf($user->lang['error_unlink'],$file));
				}
			}
		}

		// Now clear the temp folder
		$uniadmin->cleardir($temp_folder);

		$uniadmin->message(sprintf($user->lang['addon_uploaded'],$real_addon_name));
	}
	else // Nothing was uploaded
	{
		$uniadmin->message($user->lang['error_no_addon_uploaded']);
	}
}

/**
 * Gets the value from the .toc file
 *
 * @param string $file, $var, $def_val
 * @return string
 */
function get_toc_val( $file, $var, $def_val )
{
	$lines = file($file);

	$val = $def_val;
	foreach( $lines as $line )
	{
		$int_pos = strpos(strtoupper($line),strtoupper("## $var: "));
		if( $int_pos !== false )
		{
			$val = substr($line, $int_pos + strlen("## $var: ") );
			//*
			switch ( $var )
			{
				case 'Version':
					$val = strpos($val, '.$Revision:') === False ? $val : trim(substr($val, 0, strpos(substr($val, 0, strpos($val, ' $')), '.$Revision:')));
					break;
				case 'Title':
					$val = strpos($val, 'ChatMOD') === False ? $val : 'ChatMOD';
					$val = strpos($val, 'rpgo-GuildProfiler') === False ? $val : 'rpgo-GuildProfiler';
					$val = strpos($val, 'rpgo-CharacterProfiler') === False ? $val : 'rpgo-CharacterProfiler';
					break;
			}
			//*/
			$trans = array(
				'|cff7fff7f -Ace-|r' => '',
				'|cff7fff7f -Ace2-|r' => '',
				'|cff66ff33 Kirkburn|r' => 'Kirkburn',
				'|cffffffff2|r' => '2',
				'|cffff00002|r' => '2',
				'|cff00ff00Fu|r' => 'Fu',
				'|cffffffff' => '',
				'|r' => ''
			);
			$val = strtr($val, $trans);
		}
	}
	return trim($val);
}


?>